// Auto-generated. Do not edit!

// (in-package rosbag_snapshot_msgs.srv)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;

//-----------------------------------------------------------


//-----------------------------------------------------------

class TriggerSnapshotRequest {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.filename = null;
      this.topics = null;
      this.start_time = null;
      this.stop_time = null;
    }
    else {
      if (initObj.hasOwnProperty('filename')) {
        this.filename = initObj.filename
      }
      else {
        this.filename = '';
      }
      if (initObj.hasOwnProperty('topics')) {
        this.topics = initObj.topics
      }
      else {
        this.topics = [];
      }
      if (initObj.hasOwnProperty('start_time')) {
        this.start_time = initObj.start_time
      }
      else {
        this.start_time = {secs: 0, nsecs: 0};
      }
      if (initObj.hasOwnProperty('stop_time')) {
        this.stop_time = initObj.stop_time
      }
      else {
        this.stop_time = {secs: 0, nsecs: 0};
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type TriggerSnapshotRequest
    // Serialize message field [filename]
    bufferOffset = _serializer.string(obj.filename, buffer, bufferOffset);
    // Serialize message field [topics]
    bufferOffset = _arraySerializer.string(obj.topics, buffer, bufferOffset, null);
    // Serialize message field [start_time]
    bufferOffset = _serializer.time(obj.start_time, buffer, bufferOffset);
    // Serialize message field [stop_time]
    bufferOffset = _serializer.time(obj.stop_time, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type TriggerSnapshotRequest
    let len;
    let data = new TriggerSnapshotRequest(null);
    // Deserialize message field [filename]
    data.filename = _deserializer.string(buffer, bufferOffset);
    // Deserialize message field [topics]
    data.topics = _arrayDeserializer.string(buffer, bufferOffset, null)
    // Deserialize message field [start_time]
    data.start_time = _deserializer.time(buffer, bufferOffset);
    // Deserialize message field [stop_time]
    data.stop_time = _deserializer.time(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += object.filename.length;
    object.topics.forEach((val) => {
      length += 4 + val.length;
    });
    return length + 24;
  }

  static datatype() {
    // Returns string type for a service object
    return 'rosbag_snapshot_msgs/TriggerSnapshotRequest';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '09f36a11eeb5a8ba983b3be50c4e7cc7';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    string filename   # Name of bag file to save snapshot to.
                      # if it ends in .bag, this exact filename will be saved.
                      # otherwise, the current datetime and .bag will be appended to the name
                      #   example: "test" -> test2018-05-23-10-04-20.bag
                      #   example: "test.bag" -> test.bag
    string[] topics   # List of topics to include in snapshot.
                      # If empty, all buffered topics will be written
    time start_time   # Earliest timestamp for a message to be included in written bag
                      # If time(0), start at the earliest message in each topic's buffer
    time stop_time    # Latest timestamp for a message to be included in written bag
                      # If time(0), stop at the most recent message in each topic's buffer
    
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new TriggerSnapshotRequest(null);
    if (msg.filename !== undefined) {
      resolved.filename = msg.filename;
    }
    else {
      resolved.filename = ''
    }

    if (msg.topics !== undefined) {
      resolved.topics = msg.topics;
    }
    else {
      resolved.topics = []
    }

    if (msg.start_time !== undefined) {
      resolved.start_time = msg.start_time;
    }
    else {
      resolved.start_time = {secs: 0, nsecs: 0}
    }

    if (msg.stop_time !== undefined) {
      resolved.stop_time = msg.stop_time;
    }
    else {
      resolved.stop_time = {secs: 0, nsecs: 0}
    }

    return resolved;
    }
};

class TriggerSnapshotResponse {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.success = null;
      this.message = null;
    }
    else {
      if (initObj.hasOwnProperty('success')) {
        this.success = initObj.success
      }
      else {
        this.success = false;
      }
      if (initObj.hasOwnProperty('message')) {
        this.message = initObj.message
      }
      else {
        this.message = '';
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type TriggerSnapshotResponse
    // Serialize message field [success]
    bufferOffset = _serializer.bool(obj.success, buffer, bufferOffset);
    // Serialize message field [message]
    bufferOffset = _serializer.string(obj.message, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type TriggerSnapshotResponse
    let len;
    let data = new TriggerSnapshotResponse(null);
    // Deserialize message field [success]
    data.success = _deserializer.bool(buffer, bufferOffset);
    // Deserialize message field [message]
    data.message = _deserializer.string(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += object.message.length;
    return length + 5;
  }

  static datatype() {
    // Returns string type for a service object
    return 'rosbag_snapshot_msgs/TriggerSnapshotResponse';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return 'ef7a6261f820dd9de10824939dd524d6';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    
    bool success    # True if snapshot successfully written to disk
    
    string NO_DATA_MESSAGE=no messages buffered on selected topics
    string message  # Error description if failed
    
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new TriggerSnapshotResponse(null);
    if (msg.success !== undefined) {
      resolved.success = msg.success;
    }
    else {
      resolved.success = false
    }

    if (msg.message !== undefined) {
      resolved.message = msg.message;
    }
    else {
      resolved.message = ''
    }

    return resolved;
    }
};

// Constants for message
TriggerSnapshotResponse.Constants = {
  NO_DATA_MESSAGE: 'no messages buffered on selected topics',
}

module.exports = {
  Request: TriggerSnapshotRequest,
  Response: TriggerSnapshotResponse,
  md5sum() { return 'd5f2b150730729bd0435527e829e65e2'; },
  datatype() { return 'rosbag_snapshot_msgs/TriggerSnapshot'; }
};
